'
'  pb_sqldb.inc
'
'  SQL Server DB-LIB function translation of sqldb.h that is
'  included by Microsoft with SQL Server 7
'
'  Translated by Don Dickinson
'  ddickinson@usinternet.com
'  dickinson.basicguru.com
'
'  >> FIX - by DD - Oct 18, 2001
'        Agghhh, all calls in ntwdblib.dll need to be
'        declared as C-declares - CDECL not the
'        default STDCALL - this solved a lot of
'        wierd gpfs.
'
#if not %Def(%PB_SQLDB_INC)

%PB_SQLDB_INC = 1

'- Constants and structures
#include "pb_sqlfr.inc"

'// Macros for setting the PLOGINREC
'#define DBSETLHOST(a,b)    dbsetlname   ((a), (b), DBSETHOST)
'#define DBSETLUSER(a,b)    dbsetlname   ((a), (b), DBSETUSER)
'#define DBSETLPWD(a,b)     dbsetlname   ((a), (b), DBSETPWD)
'#define DBSETLAPP(a,b)     dbsetlname   ((a), (b), DBSETAPP)
'#define BCP_SETL(a,b)      bcp_setl     ((a), (b))
'#define DBSETLNATLANG(a,b) dbsetlname   ((a), (b), DBSETLANG)
'#define DBSETLPACKET(a,b)  dbsetlpacket ((a), (b))
'#define DBSETLSECURE(a)    dbsetlname   ((a), 0,   DBSETSECURE)
'#define DBSETLVERSION(a,b) dbsetlname   ((a), 0,  (b))
'#define DBSETLTIME(a,b)		dbsetlname    ((a), (LPCSTR)(ULONG)(b), DBSETLOGINTIME)
'#define DBSETLFALLBACK(a,b) dbsetlname   ((a), (b),   DBSETFALLBACK)


$DBLIB_DLL = "ntwdblib.dll"

Declare Function dblogin CDECL Lib "ntwdblib.dll" Alias "dblogin" as Long

Declare Sub dbExit CDECL Lib "ntwdblib.dll" Alias "dbexit"

Declare Function dbsetlname CDECL Lib "ntwdblib.dll" Alias "dbsetlname" _
      ( ByVal pLoginRec as Long, zString as Asciiz, ByVal i as Long ) as Long

Declare Function dbopen CDECL Lib "ntwdblib.dll" Alias "dbopen" _
      ( ByVal pLoginRec as Long, zString as Asciiz ) as Long

Declare Function dbclose CDECL Lib "ntwdblib.dll" Alias "dbclose" _
      ( ByVal dbProcess as Long ) as Long

Declare Function dbcancel CDECL Lib "ntwdblib.dll" Alias "dbcancel" _
      ( ByVal dbProcess as Long ) as Long

Declare Function dbcanquery CDECL Lib "ntwdblib.dll" Alias "dbcanquery" _
      ( ByVal dbProcess as Long ) as Long

Declare Function dbinit CDECL Lib "ntwdblib.dll" Alias "dbinit" as Dword

Declare Function dbuse CDECL Lib "ntwdblib.dll" Alias "dbuse" _
      ( ByVal dbProcess as Long, zDatabase as Asciiz ) as Long

Declare Function dbcmd CDECL Lib "ntwdblib.dll" Alias "dbcmd" _
      ( ByVal dbProcess as Long, zCmd as Asciiz ) as Long

Declare Function dbsqlexec CDECL Lib "ntwdblib.dll" Alias "dbsqlexec" _
      ( ByVal dbProcess as Long ) as Long

Declare Function dbsqlok CDECL Lib "ntwdblib.dll" Alias "dbsqlok" _
      ( ByVal dbProcess as Long ) as Long

Declare Function dbresults CDECL Lib "ntwdblib.dll" Alias "dbresults" _
      ( ByVal dbProcess as Long ) as Long

Declare Function dbnextrow CDECL Lib "ntwdblib.dll" Alias "dbnextrow" _
      ( ByVal dbProcess as Long ) as Long

Declare Function dbbind CDECL Lib "ntwdblib.dll" Alias "dbbind" _
      ( ByVal dbProcess as Long, ByVal iColNum as Long, _
        ByVal iDataType as Long, ByVal iZero as Long, _
        zBuf as Any ) as Long

Declare Function dbnumcols CDECL Lib "ntwdblib.dll" Alias "dbnumcols" _
      ( ByVal dbProcess as Long ) as Long

Declare Function dbfreelogin CDECL Lib "ntwdblib.dll" Alias "dbfreelogin" _
      ( ByVal pLogin as Long ) as Long

Declare Function dbcollen CDECL Lib "ntwdblib.dll" Alias "dbcollen" _
      ( ByVal dbProcess as Long, ByVal iCol as Long ) as Long

Declare Function dbcolnameZ CDECL Lib "ntwdblib.dll" Alias "dbcolname" _
      ( ByVal dbProcess as Long, ByVal iCol as Long ) as DWord

Declare Function dbcolsourceZ CDECL Lib "ntwdblib.dll" Alias "dbcolsource" _
      ( ByVal dbProcess as Long, ByVal iCol as Long ) as DWord

Declare Function dbcoltype CDECL Lib "ntwdblib.dll" Alias "dbcoltype" _
      ( ByVal dbProcess as Long, ByVal iCol as Long ) as Long

Declare Function dbcolutype CDECL Lib "ntwdblib.dll" Alias "dbcolutype" _
      ( ByVal dbProcess as Long, ByVal iCol as Long ) as Long

Declare Function dbcolinfo CDECL Lib "ntwdblib.dll" Alias "dbcolinfo" _
      ( ByVal dbProcess as Long, ByVal iType as Long, _
        ByVal iColumn as Long, ByVal iComputeID as Long, _
        rCol as DBCOL_TYPE ) as Long

Declare Function dbtabsourceZ CDECL Lib "ntwdblib.dll" Alias "dbtabsource" _
      ( ByVal dbProcess as Long, ByVal iCol as Long, iTable as Long ) _
        as Long

Declare Sub dbwinexit CDECL Lib "ntwdblib.dll" Alias "dbwinexit"

Declare Sub dblocklib CDECL Lib "ntwdblib.dll" Alias "dblocklib"

Declare Sub dbunlocklib CDECL Lib "ntwdblib.dll" Alias "dbunlocklib"

Declare Function dberrorhandle CDECL Lib "ntwdblib.dll" Alias "dberrorhandle" _
      ( ByVal errProc as Long ) as Long

Declare Function dbmsghandle CDECL Lib "ntwdblib.dll" Alias "dbmsghandle" _
      ( ByVal msgProc as Long ) as Long

'- stored proc
Declare function dbrpcinit CDECL Lib "ntwdblib.dll" Alias "dbrpcinit" _
      ( ByVal dbProcess as Long, zString as Asciiz, _
        ByVal iOptions as Integer ) as Long

Declare Function dbrpcexec CDECL Lib "ntwdblib.dll" Alias "dbrpcexec" _
      ( ByVal dbProcess as Long ) as Long

Declare Function dbrettype CDECL Lib "ntwdblib.dll" Alias "dbrettype" _
      ( ByVal dbProcess as Long, ByVal iRetNum as Long ) as Long

Declare Function dbretstatus CDECL Lib "ntwdblib.dll" Alias "dbretstatus" _
      ( ByVal dbProcess as Long ) as Long

Declare Function dbretnameZ CDECL Lib "ntwdblib.dll" Alias "dbretname" _
      ( ByVal dbProcess as Long, ByVal iRetNum as Long ) as Dword

Declare Function dbretlen CDECL Lib "ntwdblib.dll" Alias "dbretlen" _
      ( ByVal dbProcess as Long, ByVal iRetNum as Long ) as Long

Declare Function dbretdata CDECL Lib "ntwdblib.dll" Alias "dbretdata" _
      ( ByVal dbProcess as Long, ByVal iRetNum as Long ) as Long

Declare Function dbnumrets CDECL Lib "ntwdblib.dll" Alias "dbnumrets" _
      ( ByVal dbProcess as Long ) as Long

Declare Function dbhasretstat CDECL Lib "ntwdblib.dll" Alias "dbhasretstat" _
      ( ByVal dbProcess as Long ) as Long

Declare Function dbrettype CDECL Lib "ntwdblib.dll" Alias "dbrettype" _
      ( ByVal dbProcess as Long, ByVal iRetNum as Long ) as Long

Declare function dbrpcparam CDECL Lib "ntwdblib.dll" Alias "dbrpcparam" _
      ( ByVal dbProcess as Long, zParamName as Asciiz, _
        ByVal iStatus as Byte, ByVal iType as Long, _
        ByVal iMaxLen as Long, ByVal iDataLen as Long, _
        pByte as Any ) as Long

Declare Function dbrpcsend CDECL Lib "ntwdblib.dll" Alias "dbrpcsend" _
      ( dbProcess as Long ) as Long

Declare Function dbdatlen CDECL Lib "ntwdblib.dll" Alias "dbdatlen" _
      ( ByVal dbProcess as Long, ByVal iCol as Long ) as Long

Declare Function dbsetopt CDECL Lib "ntwdblib.dll" Alias "dbsetopt" _
      ( ByVal dbProcess as Long, ByVal iOpt as Long, _
        zParam as Asciiz ) as Long

' Two-phase commit functions
Declare Function abort_xact CDECL Lib "ntwdblib.dll" Alias "abort_xact" _
      ( ByVal pdbProcess as Long, ByVal dbInt as Long ) as Long

Declare Sub build_xact_string CDECL Lib "ntwdblib.dll" Alias "build_xact_string" _
      ( zString1 as Asciiz, zString2 as Asciiz, ByVal dbInt as Long, _
        zString3 as Asciiz)

Declare Sub close_commit CDECL Lib "ntwdblib.dll" Alias "close_commit" _
      ( ByVal dbProcess as Long )

Declare Function commit_xact CDECL Lib "ntwdblib.dll" Alias "commit_xact" _
      ( ByVal dbProcess as Long, ByVal dbInt as Long ) as Long

Declare Function open_commit CDECL Lib "ntwdblib.dll" Alias "open_commit" _
      ( ByVal pLoginRec as Long, zString as Asciiz ) as Long

Declare Function remove_xact CDECL Lib "ntwdblib.dll" Alias "remove_xact" _
      ( ByVal dbProcess as Long, ByVal dbInt as Long, ByVal dbInt2 as Long ) as Long

Declare Function dberrhandle CDECL lib "ntwdblib.dll" Alias "dberrhandle" _
      ( ByVal hCodePtr as Long ) as Long

Declare Function dbsetmaxprocs CDECL Lib "ntwdblib.dll" Alias "dbsetmaxprocs" _
      ( ByVal iMax as Integer ) as Long
#if 0
extern RETCODE      SQLAPI remove_xact (PDBPROCESS, DBINT, INT);
extern RETCODE      SQLAPI scan_xact (PDBPROCESS, DBINT);
extern DBINT        SQLAPI start_xact (PDBPROCESS, LPCSTR, LPCSTR, INT);
extern INT          SQLAPI stat_xact (PDBPROCESS, DBINT);

// BCP functions
extern DBINT        SQLAPI bcp_batch (PDBPROCESS);
extern RETCODE      SQLAPI bcp_bind (PDBPROCESS, LPCBYTE, INT, DBINT, LPCBYTE, INT, INT, INT);
extern RETCODE      SQLAPI bcp_colfmt (PDBPROCESS, INT, BYTE, INT, DBINT, LPCBYTE, INT, INT);
extern RETCODE      SQLAPI bcp_collen (PDBPROCESS, DBINT, INT);
extern RETCODE      SQLAPI bcp_colptr (PDBPROCESS, LPCBYTE, INT);
extern RETCODE      SQLAPI bcp_columns (PDBPROCESS, INT);
extern RETCODE      SQLAPI bcp_control (PDBPROCESS, INT, DBINT);
extern DBINT        SQLAPI bcp_done (PDBPROCESS);
extern RETCODE      SQLAPI bcp_exec (PDBPROCESS, LPDBINT);
extern RETCODE      SQLAPI bcp_init (PDBPROCESS, LPCSTR, LPCSTR, LPCSTR, INT);
extern RETCODE      SQLAPI bcp_moretext (PDBPROCESS, DBINT, LPCBYTE);
extern RETCODE      SQLAPI bcp_readfmt (PDBPROCESS, LPCSTR);
extern RETCODE      SQLAPI bcp_sendrow (PDBPROCESS);
extern RETCODE      SQLAPI bcp_setl (PLOGINREC, BOOL);
extern RETCODE      SQLAPI bcp_writefmt (PDBPROCESS, LPCSTR);

// Standard DB-Library functions
extern LPCBYTE      SQLAPI dbadata (PDBPROCESS, INT, INT);
extern DBINT        SQLAPI dbadlen (PDBPROCESS, INT, INT);
extern RETCODE      SQLAPI dbaltbind (PDBPROCESS, INT, INT, INT, DBINT, LPCBYTE);
extern INT          SQLAPI dbaltcolid (PDBPROCESS, INT, INT);
extern DBINT        SQLAPI dbaltlen (PDBPROCESS, INT, INT);
extern INT          SQLAPI dbaltop (PDBPROCESS, INT, INT);
extern INT          SQLAPI dbalttype (PDBPROCESS, INT, INT);
extern DBINT        SQLAPI dbaltutype (PDBPROCESS, INT, INT);
extern RETCODE      SQLAPI dbanullbind (PDBPROCESS, INT, INT, LPCDBINT);
'extern RETCODE      SQLAPI dbbind (PDBPROCESS, INT, INT, DBINT, LPBYTE);
extern LPCBYTE      SQLAPI dbbylist (PDBPROCESS, INT, LPINT);
'extern RETCODE      SQLAPI dbcancel (PDBPROCESS);
'extern RETCODE      SQLAPI dbcanquery (PDBPROCESS);
extern LPCSTR       SQLAPI dbchange (PDBPROCESS);
'extern RETCODE      SQLAPI dbclose (PDBPROCESS);
extern void         SQLAPI dbclrbuf (PDBPROCESS, DBINT);
extern RETCODE      SQLAPI dbclropt (PDBPROCESS, INT, LPCSTR);
'extern RETCODE      SQLAPI dbcmd (PDBPROCESS, LPCSTR);
extern RETCODE      SQLAPI dbcmdrow (PDBPROCESS);
extern BOOL         SQLAPI dbcolbrowse (PDBPROCESS, INT);
'extern RETCODE      SQLAPI dbcolinfo (PDBHANDLE, INT, INT, INT, LPDBCOL);
'extern DBINT        SQLAPI dbcollen (PDBPROCESS, INT);
'extern LPCSTR       SQLAPI dbcolname (PDBPROCESS, INT);
'extern LPCSTR       SQLAPI dbcolsource (PDBPROCESS, INT);
'extern INT          SQLAPI dbcoltype (PDBPROCESS, INT);
'extern DBINT        SQLAPI dbcolutype (PDBPROCESS, INT);
extern INT          SQLAPI dbconvert (PDBPROCESS, INT, LPCBYTE, DBINT, INT, LPBYTE, DBINT);
'extern DBINT        SQLAPI dbcount (PDBPROCESS);
extern INT          SQLAPI dbcurcmd (PDBPROCESS);
extern DBINT        SQLAPI dbcurrow (PDBPROCESS);
extern RETCODE      SQLAPI dbcursor (PDBCURSOR, INT, INT, LPCSTR, LPCSTR);
extern RETCODE      SQLAPI dbcursorbind (PDBCURSOR, INT, INT, DBINT, LPDBINT, LPBYTE);
extern RETCODE      SQLAPI dbcursorclose (PDBHANDLE);
extern RETCODE      SQLAPI dbcursorcolinfo (PDBCURSOR, INT, LPSTR, LPINT, LPDBINT, LPINT);
extern RETCODE      SQLAPI dbcursorfetch (PDBCURSOR,  INT, INT);
extern RETCODE      SQLAPI dbcursorfetchex (PDBCURSOR, INT, DBINT, DBINT, DBINT);
extern RETCODE      SQLAPI dbcursorinfo (PDBCURSOR, LPINT, LPDBINT);
extern RETCODE      SQLAPI dbcursorinfoex (PDBCURSOR, LPDBCURSORINFO);
extern PDBCURSOR    SQLAPI dbcursoropen (PDBPROCESS, LPCSTR, INT, INT,UINT, LPDBINT);
extern LPCBYTE      SQLAPI dbdata (PDBPROCESS, INT);
extern BOOL         SQLAPI dbdataready (PDBPROCESS);
extern RETCODE      SQLAPI dbdatecrack (PDBPROCESS, LPDBDATEREC, LPCDBDATETIME);
extern DBINT        SQLAPI dbdatlen (PDBPROCESS, INT);
extern BOOL         SQLAPI dbdead (PDBPROCESS);
'extern void         SQLAPI dbexit (void);
extern RETCODE 	    SQLAPI dbenlisttrans(PDBPROCESS, LPVOID);
extern RETCODE	    SQLAPI dbenlistxatrans(PDBPROCESS, BOOL);
extern RETCODE	    SQLAPI dbfcmd (PDBPROCESS, LPCSTR, ...);
extern DBINT        SQLAPI dbfirstrow (PDBPROCESS);
extern void         SQLAPI dbfreebuf (PDBPROCESS);
'extern void         SQLAPI dbfreelogin (PLOGINREC);
extern void         SQLAPI dbfreequal (LPCSTR);
extern LPSTR        SQLAPI dbgetchar (PDBPROCESS, INT);
extern SHORT        SQLAPI dbgetmaxprocs (void);
extern INT          SQLAPI dbgetoff (PDBPROCESS, DBUSMALLINT, INT);
extern UINT         SQLAPI dbgetpacket (PDBPROCESS);
extern STATUS       SQLAPI dbgetrow (PDBPROCESS, DBINT);
extern INT          SQLAPI dbgettime (void);
extern LPVOID       SQLAPI dbgetuserdata (PDBPROCESS);
'extern BOOL         SQLAPI dbhasretstat (PDBPROCESS);
'extern LPCSTR       SQLAPI dbinit (void);
extern BOOL         SQLAPI dbisavail (PDBPROCESS);
extern BOOL         SQLAPI dbiscount (PDBPROCESS);
extern BOOL         SQLAPI dbisopt (PDBPROCESS, INT, LPCSTR);
extern DBINT        SQLAPI dblastrow (PDBPROCESS);
'extern PLOGINREC    SQLAPI dblogin (void);
extern RETCODE      SQLAPI dbmorecmds (PDBPROCESS);
extern RETCODE      SQLAPI dbmoretext (PDBPROCESS, DBINT, LPCBYTE);
extern LPCSTR       SQLAPI dbname (PDBPROCESS);
'extern STATUS       SQLAPI dbnextrow (PDBPROCESS);
extern RETCODE      SQLAPI dbnullbind (PDBPROCESS, INT, LPCDBINT);
extern INT          SQLAPI dbnumalts (PDBPROCESS, INT);
'extern INT          SQLAPI dbnumcols (PDBPROCESS);
extern INT          SQLAPI dbnumcompute (PDBPROCESS);
extern INT          SQLAPI dbnumorders (PDBPROCESS);
'extern INT          SQLAPI dbnumrets (PDBPROCESS);
'extern PDBPROCESS   SQLAPI dbopen (PLOGINREC, LPCSTR);
extern INT          SQLAPI dbordercol (PDBPROCESS, INT);
extern RETCODE      SQLAPI dbprocinfo (PDBPROCESS, LPDBPROCINFO);
extern void         SQLAPI dbprhead (PDBPROCESS);
extern RETCODE      SQLAPI dbprrow (PDBPROCESS);
extern LPCSTR       SQLAPI dbprtype (INT);
extern LPCSTR       SQLAPI dbqual (PDBPROCESS, INT, LPCSTR);
extern DBINT        SQLAPI dbreadpage (PDBPROCESS, LPCSTR, DBINT, DBINT, LPBYTE);
extern DBINT        SQLAPI dbreadtext (PDBPROCESS, LPVOID, DBINT);
'extern RETCODE      SQLAPI dbresults (PDBPROCESS);
'extern LPCBYTE      SQLAPI dbretdata (PDBPROCESS, INT);
'extern DBINT        SQLAPI dbretlen (PDBPROCESS, INT);
'extern LPCSTR       SQLAPI dbretname (PDBPROCESS, INT);
'extern DBINT        SQLAPI dbretstatus (PDBPROCESS);
''extern INT          SQLAPI dbrettype (PDBPROCESS, INT);
extern RETCODE      SQLAPI dbrows (PDBPROCESS);
extern STATUS       SQLAPI dbrowtype (PDBPROCESS);
'extern RETCODE      SQLAPI dbrpcinit (PDBPROCESS, LPCSTR, DBSMALLINT);
'extern RETCODE      SQLAPI dbrpcparam (PDBPROCESS, LPCSTR, BYTE, INT, DBINT, DBINT, LPCBYTE);
'extern RETCODE      SQLAPI dbrpcsend (PDBPROCESS);
'extern RETCODE      SQLAPI dbrpcexec (PDBPROCESS);
extern void         SQLAPI dbrpwclr (PLOGINREC);
extern RETCODE      SQLAPI dbrpwset (PLOGINREC, LPCSTR, LPCSTR, INT);
extern INT          SQLAPI dbserverenum (USHORT, LPSTR, USHORT, LPUSHORT);
extern void         SQLAPI dbsetavail (PDBPROCESS);
'extern RETCODE      SQLAPI dbsetmaxprocs (SHORT);
'extern RETCODE      SQLAPI dbsetlname (PLOGINREC, LPCSTR, INT);
extern RETCODE      SQLAPI dbsetlogintime (INT);
extern RETCODE      SQLAPI dbsetlpacket (PLOGINREC, USHORT);
extern RETCODE      SQLAPI dbsetnull (PDBPROCESS, INT, INT, LPCBYTE);
extern RETCODE      SQLAPI dbsetopt (PDBPROCESS, INT, LPCSTR);
extern RETCODE      SQLAPI dbsettime (INT);
extern void         SQLAPI dbsetuserdata (PDBPROCESS, LPVOID);
'extern RETCODE      SQLAPI dbsqlexec (PDBPROCESS);
'extern RETCODE      SQLAPI dbsqlok (PDBPROCESS);
extern RETCODE      SQLAPI dbsqlsend (PDBPROCESS);
extern RETCODE      SQLAPI dbstrcpy (PDBPROCESS, INT, INT, LPSTR);
extern INT          SQLAPI dbstrlen (PDBPROCESS);
extern BOOL         SQLAPI dbtabbrowse (PDBPROCESS, INT);
extern INT          SQLAPI dbtabcount (PDBPROCESS);
extern LPCSTR       SQLAPI dbtabname (PDBPROCESS, INT);
extern LPCSTR       SQLAPI dbtabsource (PDBPROCESS, INT, LPINT);
extern INT          SQLAPI dbtsnewlen (PDBPROCESS);
extern LPCDBBINARY  SQLAPI dbtsnewval (PDBPROCESS);
extern RETCODE      SQLAPI dbtsput (PDBPROCESS, LPCDBBINARY, INT, INT, LPCSTR);
extern LPCDBBINARY  SQLAPI dbtxptr (PDBPROCESS, INT);
extern LPCDBBINARY  SQLAPI dbtxtimestamp (PDBPROCESS, INT);
extern LPCDBBINARY  SQLAPI dbtxtsnewval (PDBPROCESS);
extern RETCODE      SQLAPI dbtxtsput (PDBPROCESS, LPCDBBINARY, INT);
extern RETCODE      SQLAPI dbuse (PDBPROCESS, LPCSTR);
extern BOOL         SQLAPI dbvarylen (PDBPROCESS, INT);
extern BOOL         SQLAPI dbwillconvert (INT, INT);
extern RETCODE      SQLAPI dbwritepage (PDBPROCESS, LPCSTR, DBINT, DBINT, DBINT, LPBYTE);
extern RETCODE      SQLAPI dbwritetext (PDBPROCESS, LPCSTR, LPCDBBINARY, DBTINYINT, LPCDBBINARY, BOOL, DBINT, LPCBYTE);
extern RETCODE      SQLAPI dbupdatetext(PDBPROCESS, LPCSTR, LPCDBBINARY, LPCDBBINARY, INT, DBINT, DBINT, LPCSTR, DBINT, LPCDBBINARY);
#endif

#endif